//=============================================================================
//
// file :         DigitalDelayGeneratorClass.h
//
// description :  Include for the DigitalDelayGeneratorClass root class.
//                This class is represents the singleton class for
//                the DigitalDelayGenerator device class.
//                It contains all properties and methods which the 
//                DigitalDelayGenerator requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: xavela $
//
// $Revision: 1.2 $
//
// $Log: not supported by cvs2svn $
// Revision 1.1  2009/01/21 13:04:56  stephle
// initial import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _DIGITALDELAYGENERATORCLASS_H
#define _DIGITALDELAYGENERATORCLASS_H

#include <tango.h>
#include <DigitalDelayGenerator.h>


namespace DigitalDelayGenerator_ns
{//=====================================
//	Define classes for attributes
//=====================================
class activateChannelDAttrib: public Tango::Attr
{
public:
	activateChannelDAttrib():Attr("activateChannelD", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~activateChannelDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_activateChannelD(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_activateChannelD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_activateChannelD_allowed(ty);}
};

class pulseWidthChannelDAttrib: public Tango::Attr
{
public:
	pulseWidthChannelDAttrib():Attr("pulseWidthChannelD", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseWidthChannelDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseWidthChannelD(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseWidthChannelD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseWidthChannelD_allowed(ty);}
};

class pulseDelayChannelDAttrib: public Tango::Attr
{
public:
	pulseDelayChannelDAttrib():Attr("pulseDelayChannelD", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseDelayChannelDAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseDelayChannelD(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseDelayChannelD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseDelayChannelD_allowed(ty);}
};

class activateChannelCAttrib: public Tango::Attr
{
public:
	activateChannelCAttrib():Attr("activateChannelC", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~activateChannelCAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_activateChannelC(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_activateChannelC(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_activateChannelC_allowed(ty);}
};

class pulseWidthChannelCAttrib: public Tango::Attr
{
public:
	pulseWidthChannelCAttrib():Attr("pulseWidthChannelC", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseWidthChannelCAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseWidthChannelC(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseWidthChannelC(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseWidthChannelC_allowed(ty);}
};

class pulseDelayChannelCAttrib: public Tango::Attr
{
public:
	pulseDelayChannelCAttrib():Attr("pulseDelayChannelC", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseDelayChannelCAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseDelayChannelC(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseDelayChannelC(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseDelayChannelC_allowed(ty);}
};

class activateChannelBAttrib: public Tango::Attr
{
public:
	activateChannelBAttrib():Attr("activateChannelB", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~activateChannelBAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_activateChannelB(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_activateChannelB(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_activateChannelB_allowed(ty);}
};

class pulseWidthChannelBAttrib: public Tango::Attr
{
public:
	pulseWidthChannelBAttrib():Attr("pulseWidthChannelB", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseWidthChannelBAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseWidthChannelB(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseWidthChannelB(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseWidthChannelB_allowed(ty);}
};

class pulseDelayChannelBAttrib: public Tango::Attr
{
public:
	pulseDelayChannelBAttrib():Attr("pulseDelayChannelB", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseDelayChannelBAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseDelayChannelB(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseDelayChannelB(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseDelayChannelB_allowed(ty);}
};

class activateChannelAAttrib: public Tango::Attr
{
public:
	activateChannelAAttrib():Attr("activateChannelA", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~activateChannelAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_activateChannelA(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_activateChannelA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_activateChannelA_allowed(ty);}
};

class pulseWidthChannelAAttrib: public Tango::Attr
{
public:
	pulseWidthChannelAAttrib():Attr("pulseWidthChannelA", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseWidthChannelAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseWidthChannelA(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseWidthChannelA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseWidthChannelA_allowed(ty);}
};

class pulseDelayChannelAAttrib: public Tango::Attr
{
public:
	pulseDelayChannelAAttrib():Attr("pulseDelayChannelA", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~pulseDelayChannelAAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_pulseDelayChannelA(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->write_pulseDelayChannelA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_pulseDelayChannelA_allowed(ty);}
};

class shotsCounterAttrib: public Tango::Attr
{
public:
	shotsCounterAttrib():Attr("shotsCounter", Tango::DEV_ULONG, Tango::READ) {};
	~shotsCounterAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<DigitalDelayGenerator *>(dev))->read_shotsCounter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_shotsCounter_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class RecallModuleConfigurationClass : public Tango::Command
{
public:
	RecallModuleConfigurationClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RecallModuleConfigurationClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RecallModuleConfigurationClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_RecallModuleConfiguration_allowed(any);}
};



class SaveModuleConfigurationClass : public Tango::Command
{
public:
	SaveModuleConfigurationClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveModuleConfigurationClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveModuleConfigurationClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_SaveModuleConfiguration_allowed(any);}
};



class ResetShotsCmd : public Tango::Command
{
public:
	ResetShotsCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetShotsCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetShotsCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_ResetShots_allowed(any);}
};



class ClearErrorsClass : public Tango::Command
{
public:
	ClearErrorsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ClearErrorsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ClearErrorsClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_ClearErrors_allowed(any);}
};



class HardwareResetCmd : public Tango::Command
{
public:
	HardwareResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	HardwareResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~HardwareResetCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<DigitalDelayGenerator *>(dev))->is_HardwareReset_allowed(any);}
};



//
// The DigitalDelayGeneratorClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	DigitalDelayGeneratorClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static DigitalDelayGeneratorClass *init(const char *);
	static DigitalDelayGeneratorClass *instance();
	~DigitalDelayGeneratorClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	DigitalDelayGeneratorClass(string &);
	static DigitalDelayGeneratorClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace DigitalDelayGenerator_ns

#endif // _DIGITALDELAYGENERATORCLASS_H
